// C Source File
// Created 5/16/2005; 4:49:53 PM

// Delete or comment out the items you do not need.
#define COMMENT_STRING         "Place your comment here."
#define COMMENT_PROGRAM_NAME   "Place your program name here."
#define COMMENT_VERSION_STRING "Place your version string here."
#define COMMENT_VERSION_NUMBER 0,0,0,0 /* major, minor, revision, subrevision */

#include <tigcclib.h>
#include "mytiheader.h"
#include "obsidio.h"
#include "obsidiologo.h"

static const char *turnText[2]={
  "White's",
  "Black's"
};

void writeInt(int x,int y,int theInt)
{
  char intStr[10];
  sprintf(intStr,"%d%c",theInt,0);
  DrawStr(x,y,intStr,A_NORMAL);
}

int fullScreenMode;

void drawStatus(EBOARD *theBoard,int x0,int y0,int x1,int y1)
{
  int wScore,bScore;
  if (fullScreenMode) return;
  FillBox(x0,y0,x1,y1,A_REVERSE);
  DrawLine(x0,y0,x0,y1,A_NORMAL);
  x0++;
  DrawStr(x0,y0,turnText[theBoard->curTurn],A_NORMAL);
  DrawStr(x0,y0+10,"Turn",A_NORMAL);
  DrawStr(x0,y0+25,"White:",A_NORMAL);
  DrawStr(x0,y0+50,"Black:",A_NORMAL);
  getScores(theBoard,&wScore,&bScore);
  writeInt(x0,y0+35,wScore);
  writeInt(x0,y0+60,bScore);
}

void drawPiece(BOARDAREA *boardSpot,int x,int y,int player)
{
  int x0,y0,x1,y1;
  int xdbuffer,ydbuffer;
  x=x*2+1;
  y=y*2+1;
  x0=boardSpot->xLoc+boardSpot->xSquareSize*x;
  y0=boardSpot->yLoc+boardSpot->ySquareSize*y;
  x1=x0+boardSpot->xSquareSize;
  y1=y0+boardSpot->ySquareSize;
  FillBox(x0,y0,x1-1,y1-1,A_REVERSE);
  if (player==NONEXISTANT) return;
  DrawBox(x0,y0,x1-1,y1-1,A_NORMAL);
  if (player==WHITE)
  {
  	xdbuffer=(x1-x0)/2-1;
  	ydbuffer=(y1-y0)/2-1;
  	FillBox(x0+xdbuffer,y0+ydbuffer,x1-xdbuffer-1,y1-ydbuffer-1,A_NORMAL);
  }
  else if (player==BLACK)
    FillBox(x0,y0,x1-1,y1-1,A_NORMAL);
}

void drawArrow(BOARDAREA *boardSpot,int x,int y,int refLoc,int arrowDirection,int attr)
{
  int x0,y0,x1,y1;
  int middleX,middleY;
  if (arrowDirection==NOARROW) return;
  refLoc=refLoc%8;
	x=(x*2+1)+dirChanges[refLoc][0];
	y=(y*2+1)+dirChanges[refLoc][1];
	x0=boardSpot->xLoc+boardSpot->xSquareSize*x;
  y0=boardSpot->yLoc+boardSpot->ySquareSize*y;
  x1=x0+boardSpot->xSquareSize;
  y1=y0+boardSpot->ySquareSize;
  middleX=(x0+x1)/2;
  middleY=(y0+y1)/2;
  if (arrowDirection==ARROWIN)
  	refLoc+=4;
  if (refLoc>=8) refLoc-=8;
  switch (refLoc)
  {
  	case 0:
  		DrawLine(middleX,y1-1,middleX,y0,attr);
  		DrawLine(middleX-1,y0+1,middleX-1,y0+1,attr);
  		DrawLine(middleX+1,y0+1,middleX+1,y0+1,attr);
  		break;
  	case 1:
  		DrawLine(x0,y1-1,x1-1,y0,attr);
  		DrawLine(x1-2,y0,x1-2,y0,attr);
  		DrawLine(x1-1,y0+1,x1-1,y0+1,attr);
  		break;
  	case 2:
  		DrawLine(x0,middleY,x1-1,middleY,attr);
  		DrawLine(x1-2,middleY-1,x1-2,middleY-1,attr);
  		DrawLine(x1-2,middleY+1,x1-2,middleY+1,attr);
  		break;
  	case 3:
  		DrawLine(x0,y0,x1-1,y1-1,attr);
  		DrawLine(x1-2,y1-1,x1-2,y1-1,attr);
  		DrawLine(x1-1,y1-2,x1-1,y1-2,attr);
  		break;
  	case 4:
  		DrawLine(middleX,y0,middleX,y1-1,attr);
  		DrawLine(middleX-1,y1-2,middleX-1,y1-2,attr);
  		DrawLine(middleX+1,y1-2,middleX+1,y1-2,attr);
  		break;
  	case 5:
  		DrawLine(x1-1,y0,x0,y1-1,attr);
  		DrawLine(x0,y1-2,x0,y1-2,attr);
  		DrawLine(x0+1,y1-1,x0+1,y1-1,attr);
  		break;
  	case 6:
  		DrawLine(x0,middleY,x1-1,middleY,attr);
  		DrawLine(x0+1,middleY-1,x0+1,middleY-1,attr);
  		DrawLine(x0+1,middleY+1,x0+1,middleY+1,attr);
  		break;
  	case 7:
  		DrawLine(x1-1,y1-1,x0,y0,attr);
  		DrawLine(x0,y0+1,x0,y0+1,attr);
  		DrawLine(x0+1,y0,x0+1,y0,attr);
  		break;
  }
}

void drawBoard(EBOARD *theBoard)
{
	int x0=theBoard->x0,y0=theBoard->y0,x1=theBoard->x1+1,y1=theBoard->y1+1;
	int x,y,t;
	EPEG *ptr=theBoard->board;
	char *dptr;
	BOARDAREA theSpot=theBoard->theArea;
	FillBox(x0,y0,x1,y1,A_REVERSE);
	for (y=0;y<theBoard->yDim;y++)
		for (x=0;x<theBoard->xDim;x++)
		{
			drawPiece(&theSpot,x,y,ptr->player);
			/*if (ptr->player<0)
			{
				ptr++;
				continue;
			}*/
			dptr=ptr->dirFlags;
			for (t=0;t<8;t++)
			{
				drawArrow(&theSpot,x,y,t,*(dptr++),A_NORMAL);
			}
			ptr++;
		}
}

/*
typedef struct
{
  int curTurn;
  int xDim,yDim;
  int totalPegs;
  int x0,y0,x1,y1;
  EPEG *board;
  BOARDAREA theArea;
} EBOARD;

typedef struct
{
	int xLoc,yLoc;
	int xSquareSize,ySquareSize;
	int xDim,yDim;
} BOARDAREA;
*/



int pickMove(EBOARD *theBoard,ETURN *turnBuffer,int *cursX,int *cursY,int statusX,int statusY)
{
	short lastDir,k;
	DrawStr(statusX,statusY,"From?",A_REPLACE);
	while (1)
	{
		drawBoxAroundArea(&theBoard->theArea,*cursX*2+1,*cursY*2+1,A_XOR);
		lastDir=getArrowPress();
		drawBoxAroundArea(&theBoard->theArea,*cursX*2+1,*cursY*2+1,A_XOR);
		if (lastDir==d_EXIT) return d_EXIT;
		if (lastDir==d_ENTER)
		{
			if (theBoard->board[*cursX+*cursY*theBoard->xDim].player==theBoard->curTurn)
				break;
			else
			{
				if (theBoard->board[*cursX+*cursY*theBoard->xDim].player==NOBODY)
					MessageBox("OBSIDIO","This piece is nobodys.",BT_NONE,BT_OK);
				else
					MessageBox("OBSIDIO","This piece isn't yours.",BT_NONE,BT_OK);
				return d_ENTER;
			}
		}
		*cursX+=dirChanges[lastDir][0];
		if (*cursX<0) *cursX=0;
		else if (*cursX>=theBoard->xDim) *cursX=theBoard->xDim-1;
		*cursY+=dirChanges[lastDir][1];
		if (*cursY<0) *cursY=0;
		else if (*cursY>=theBoard->yDim) *cursY=theBoard->yDim-1;
	}
	DrawStr(statusX,statusY,"To?  ",A_REPLACE);
	lastDir=seekLegalMove(theBoard,*cursX,*cursY,0,1);
	if (lastDir==d_EXIT)
	{
		MessageBox("OBSIDIO","You cannot move with this piece.",BT_NONE,BT_OK);
		return d_ENTER;
	}
	while (1)
	{
		drawArrow(&theBoard->theArea,*cursX,*cursY,lastDir,ARROWOUT,A_XOR);
		k=getArrowPress();
		drawArrow(&theBoard->theArea,*cursX,*cursY,lastDir,ARROWOUT,A_XOR);
		if (k==d_EXIT) return d_ENTER;
		if (k==d_ENTER)
		{
			turnBuffer->startX=*cursX;
			turnBuffer->startY=*cursY;
			turnBuffer->dir=lastDir;
			if (!legalMove(theBoard,turnBuffer))
			{
				MessageBox("OBSIDIO","Illegal move.",BT_NONE,BT_OK);
				continue;
			}
			*cursX+=dirChanges[lastDir][0];
			*cursY+=dirChanges[lastDir][1];
			return lastDir;
		}
		if (k==d_RIGHT)
		{
			if (lastDir==7) lastDir=0;
			else if (lastDir==0) lastDir=1;
			else if (lastDir==5) lastDir=4;
			else if (lastDir==4) lastDir=3;
			else if (lastDir==6) lastDir=2;
			else lastDir=2;
		}
		else if (k==d_LEFT)
		{
			if (lastDir==1) lastDir=0;
			else if (lastDir==0) lastDir=7;
			else if (lastDir==4) lastDir=5;
			else if (lastDir==3) lastDir=4;
			else if (lastDir==2) lastDir=6;
			else lastDir=6;
		}
		else if (k==d_UP)
		{
			if (lastDir==5) lastDir=6;
			else if (lastDir==6) lastDir=7;
			else if (lastDir==4) lastDir=0;
			else if (lastDir==3) lastDir=2;
			else if (lastDir==2) lastDir=1;
			else lastDir=0;
		}
		else if (k==d_DOWN)
		{
			if (lastDir==6) lastDir=5;
			else if (lastDir==7) lastDir=6;
			else if (lastDir==0) lastDir=4;
			else if (lastDir==2) lastDir=3;
			else if (lastDir==1) lastDir=2;
			else lastDir=4;
		}
	}
}

#define CHOOSE_NEW					1
#define CHOOSE_RESUME				2
#define CHOOSE_LOAD					3
#define CHOOSE_SAVE					4
#define CHOOSE_OPTIONS			5
#define CHOOSE_REPLAYS			6
#define CHOOSE_EXIT					7
#define CHOOSE_LOADSAVE			8
#define CHOOSE_LOADREPLAY		9
#define CHOOSE_WATCHCREPLAY	10
#define CHOOSE_TUTORIAL			11

MMENUITEM mainMenuItemsStart[]=
{
	{(char*)"New Game",stdMenu,CHOOSE_NEW},
  {(char*)"Load Game...",stdMenu,CHOOSE_LOAD},
  {(char*)"Options",stdMenu,CHOOSE_OPTIONS},
  {(char*)"Replays",stdMenu,CHOOSE_REPLAYS},
  {(char*)"Exit",stdMenu,CHOOSE_EXIT}
};

MMENUITEM mainMenuItemsDuring[]=
{
	{(char*)"Resume Game",stdMenu,CHOOSE_RESUME},
	{(char*)"New Game",stdMenu,CHOOSE_NEW},
  {(char*)"Load/Save",stdMenu,CHOOSE_LOADSAVE},
  {(char*)"Options",stdMenu,CHOOSE_OPTIONS},
  {(char*)"Replays",stdMenu,CHOOSE_REPLAYS},
  {(char*)"Exit",stdMenu,CHOOSE_EXIT}
};

MMENU mainMenu={
  0,40,159,
  6,
  mainMenuItemsStart
};

MMENUITEM loadSaveMenuItems[]=
{
	{(char*)"Load Game...",stdMenu,CHOOSE_LOAD},
	{(char*)"Save Game...",stdMenu,CHOOSE_SAVE},
	{(char*)"Return",stdMenu,CHOOSE_EXIT}
};

MMENU loadSaveMenu={
	0,40,159,3,loadSaveMenuItems
};

MMENUITEM replaysMenuItems[]=
{
	{(char*)"Load Replay (Game)",stdMenu,CHOOSE_LOADREPLAY},
	{(char*)"Rewatch Current Game",stdMenu,CHOOSE_WATCHCREPLAY},
	{(char*)"Tutorial",stdMenu,CHOOSE_TUTORIAL},
	{(char*)"Return",stdMenu,CHOOSE_EXIT}
};

MMENU replaysMenu={
	0,40,159,4,replaysMenuItems
};

#define MAXROWS 7
#define MAXCOLS 7

int curXDim=4,curYDim=4;
int player1Type,player2Type;

int toggleFullScreenMode(EBOARD *theBoard)
{
	if (fullScreenMode)
	{
		
		return 1;
	}
	else
	{
		
		return 0;
	}
}

#include "optionsmenu.h"

void resumeGame(void)
{
	FontSetSys(F_8x10);
  ClrScr();
}

void startGame(EBOARD *theBoard,int *cursX,int *cursY,int xDim,int yDim)
{
	if (xDim<yDim)
		*theBoard=setupBoard(0,0,100*xDim/yDim-1,99,xDim,yDim);
	else
		*theBoard=setupBoard(0,0,99,100*yDim/xDim-1,xDim,yDim);
	cursX[0]=0;
  cursY[0]=0;
  cursX[1]=xDim-1;
  cursY[1]=yDim-1;
  resumeGame();
}

void gameLoop(EBOARD *theBoard,int *cursX,int *cursY)
{
	ETURN turnMove;
	int pmr;
	drawBoard(theBoard);
  drawStatus(theBoard,100,0,159,99);
  while (1)
  {
redoPick:
  	pmr=pickMove(theBoard,&turnMove,cursX+theBoard->curTurn,cursY+theBoard->curTurn,101,90);
  	if (pmr==d_EXIT)
	  	return;
  	if (pmr==d_ENTER) goto redoPick;
  	processTurn(theBoard,&turnMove);
  	addTurnToHistory(theBoard,&turnMove);
  	changeTurn(theBoard);
  	drawBoard(theBoard);
  	drawStatus(theBoard,100,0,159,99);
  }
}

void _main(void)
{
  EBOARD theBoard;
  EBOARD replayBoard;
  int cursX[2],cursY[2];
  int replaycursX[2],replaycursY[2];
  int menuResponse=0;
  int menuMeaning;
  int subMenuResponse;
  int clsFlag=0;
  long i;
  ETURN *loadGameBuffer;
  curXDim=6; curYDim=6;
  player1Type=0; player2Type=0;
  fullScreenMode=0;
  theBoard.xDim=-1;
  replayBoard.xDim=-1;
  mainMenu.theMenuItems=mainMenuItemsStart;
  mainMenu.numOfItems=5;
  while (1)
	{
backToMainMenu:
		ClrScr();
		BitmapPut(0,0,&ObsidioLogo,&(SCR_RECT){{0, 0, 159, 39}},A_NORMAL);
		DrawLine(0,39,159,39,A_NORMAL);
		if (clsFlag)
			menuMeaning=CHOOSE_LOADSAVE;
		else
		{
			clsFlag=0;
		  menuMeaning=runMenu(mainMenu,&menuResponse);
		}
	  if (menuMeaning==d_EXIT||menuMeaning==CHOOSE_EXIT) break;
	  if (menuMeaning==CHOOSE_NEW)
	  {
	  	startGame(&theBoard,cursX,cursY,curXDim,curYDim);
	  }
	  if (menuMeaning==CHOOSE_RESUME)
	  {
	  	if (theBoard.xDim==-1)
	  	{
	  		startGame(&theBoard,cursX,cursY,curXDim,curYDim);
	  	}
	  	else
	  	{
	  		resumeGame();
	  	}
	  }
	  if (menuMeaning==CHOOSE_LOADSAVE)
	  {
	  	if (clsFlag==0)
	  	{
		  	ClrScr();
				BitmapPut(0,0,&ObsidioLogo,&(SCR_RECT){{0, 0, 159, 39}},A_NORMAL);
				DrawLine(0,39,159,39,A_NORMAL);
		  	subMenuResponse=0;
	  	}
	  	menuMeaning=runMenu(loadSaveMenu,&subMenuResponse);
	  	if (menuMeaning==d_EXIT||menuMeaning==CHOOSE_EXIT)
	  	{
	  		clsFlag=0;
	  		goto backToMainMenu;
	  	}
	  	clsFlag=1;
	  }
	  if (menuMeaning==CHOOSE_LOAD)
	  {
	  	loadGameBuffer=chooseFilePtr();
	  	if (!loadGameBuffer) goto backToMainMenu;
	  	if (loadGameBuffer->startX>30||loadGameBuffer->startY>30)
	  	{
	  		MessageBox("OBSIDIO","Not a saved game file.",BT_NONE,BT_OK);
	  		goto backToMainMenu;
	  	}
	  	if (theBoard.xDim>-1) freeBoard(&theBoard);
	  	startGame(&theBoard,cursX,cursY,loadGameBuffer->startX,loadGameBuffer->startY);
	  	cursX[0]=loadGameBuffer[1].startX; cursY[0]=loadGameBuffer[1].startY;
	  	cursX[1]=loadGameBuffer[2].startX; cursY[1]=loadGameBuffer[2].startY;
	  	for (i=3;i<=loadGameBuffer->dir;i++)
	  	{
	  		processTurn(&theBoard,loadGameBuffer+i);
	  		addTurnToHistory(&theBoard,loadGameBuffer+i);
	  		changeTurn(&theBoard);
	  	}
	  	clsFlag=0;
	  }
	  if (menuMeaning==CHOOSE_SAVE)
	  {
	  	if (theBoard.xDim==-1) MessageBox("OBSIDIO","You don't have anything to save yet.",BT_NONE,BT_OK);
	  		else
	  		{
	  			theBoard.turnHistory->dir=theBoard.turnHistoryCount-1;
	  			theBoard.turnHistory[1].startX=cursX[0]; theBoard.turnHistory[1].startY=cursY[0];
	  			theBoard.turnHistory[2].startX=cursX[1]; theBoard.turnHistory[2].startY=cursY[1];
	  			clsFlag=writeFile(chooseSaveFile(),theBoard.turnHistory,theBoard.turnHistoryCount*sizeof(ETURN));
	  			clsFlag=1-clsFlag;
	  		}
	  	goto backToMainMenu;
	  }
	  if (menuMeaning==CHOOSE_OPTIONS)
	  {
	  	subMenuResponse=0;
	  	ClrScr();
	  	refreshOptionsMenu();
	  	runMenu(optionsMenu,&subMenuResponse);
	  	goto backToMainMenu;
	  }
	  if (menuMeaning==CHOOSE_REPLAYS)
	  {
backToReplaysMenu:
	  	ClrScr();
			BitmapPut(0,0,&ObsidioLogo,&(SCR_RECT){{0, 0, 159, 39}},A_NORMAL);
			DrawLine(0,39,159,39,A_NORMAL);
	  	subMenuResponse=0;
	  	menuMeaning=runMenu(replaysMenu,&subMenuResponse);
	  	if (menuMeaning==CHOOSE_LOADREPLAY)
	  	{
	  		loadGameBuffer=chooseFilePtr();
		  	if (!loadGameBuffer) goto backToReplaysMenu;
		  	if (loadGameBuffer->startX>30||loadGameBuffer->startY>30)
		  	{
		  		MessageBox("OBSIDIO","Not a saved game file.",BT_NONE,BT_OK);
		  		goto backToReplaysMenu;
		  	}
		  	if (replayBoard.xDim>-1) freeBoard(&replayBoard);
		  	startGame(&replayBoard,replaycursX,replaycursY,loadGameBuffer->startX,loadGameBuffer->startY);
		  	cursX[0]=loadGameBuffer[1].startX; cursY[0]=loadGameBuffer[1].startY;
	  		cursX[1]=loadGameBuffer[2].startX; cursY[1]=loadGameBuffer[2].startY;
		  	drawBoard(&replayBoard);
  			drawStatus(&replayBoard,100,0,159,99);
  			if (ngetchx()==KEY_ESC) goto backToReplaysMenu;
		  	for (i=3;i<=loadGameBuffer->dir;i++)
		  	{
		  		processTurn(&replayBoard,loadGameBuffer+i);
		  		addTurnToHistory(&replayBoard,loadGameBuffer+i);
		  		changeTurn(&replayBoard);
		  		drawBoard(&replayBoard);
  				drawStatus(&replayBoard,100,0,159,99);
  				if (ngetchx()==KEY_ESC) break;
		  	}
		  	if (replayBoard.xDim>-1) freeBoard(&replayBoard);
		  	goto backToReplaysMenu;
	  	}
	  	if (menuMeaning==CHOOSE_WATCHCREPLAY)
	  	{
	  		if (theBoard.xDim==-1) MessageBox("OBSIDIO","You don't have a game yet.",BT_NONE,BT_OK);
	  		else
	  		{
	  			startGame(&replayBoard,replaycursX,replaycursY,theBoard.turnHistory->startX,theBoard.turnHistory->startY);
			  	cursX[0]=theBoard.turnHistory[1].startX; cursY[0]=theBoard.turnHistory[1].startY;
	  			cursX[1]=theBoard.turnHistory[2].startX; cursY[1]=theBoard.turnHistory[2].startY;
			  	drawBoard(&replayBoard);
  				drawStatus(&replayBoard,100,0,159,99);
  				if (ngetchx()==KEY_ESC) goto backToReplaysMenu;
			  	for (i=3;i<theBoard.turnHistoryCount;i++)
			  	{
			  		processTurn(&replayBoard,theBoard.turnHistory+i);
			  		addTurnToHistory(&replayBoard,theBoard.turnHistory+i);
			  		changeTurn(&replayBoard);
			  		drawBoard(&replayBoard);
	  				drawStatus(&replayBoard,100,0,159,99);
	  				if (ngetchx()==KEY_ESC) break;
			  	}
			  	if (replayBoard.xDim>-1) freeBoard(&replayBoard);
		  		goto backToReplaysMenu;
	  		}
	  	}
	  	goto backToMainMenu;
	  }
	  gameLoop(&theBoard,cursX,cursY);
	  mainMenu.theMenuItems=mainMenuItemsDuring;
  	mainMenu.numOfItems=6;
	}
	if (theBoard.xDim>-1) freeBoard(&theBoard);
	if (replayBoard.xDim>-1) freeBoard(&replayBoard);
}
